import { readdir as q, readFile as N, writeFile as Q } from "fs/promises";
import { existsSync as T, mkdirSync as W } from "fs";
import { normalize as I, join as Z, extname as C } from "path";
import H from "crypto";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function G(t, e = 0) {
  const r = [], c = [], f = [];
  let u = "", l = e;
  const p = (a) => (e = l, { type: a, value: O(), position: { start: e, end: l } }), P = (a) => {
    a.value = O(), a.position.start = e, a.position.end = l;
  }, b = () => t[++l], J = () => l < t.length - 1 ? t[l + 1] : "", A = () => l > 0 ? t[l - 1] : "", O = () => t.substring(e, l + 1), E = (a) => /["'`0-9+-]/.test(a), j = (a) => /[a-zA-Z_$]/.test(a), x = (a) => /[(){},:;.[\]?!=<>]/.test(a), $ = (a) => /\//.test(a) && /\*/.test(J()), S = (a, o) => {
    if (!o)
      o = p("Literal"), r.push(o);
    else {
      if (f.length === 0 && !/[0-9.]/.test(a))
        return y(a);
      P(o);
    }
    return f.length === 0 && /["'`]/.test(a) ? f.push(a) : f.length > 0 && f[f.length - 1] === a && (/\\/.test(A()) || f.pop()), S(b(), o);
  }, s = (a, o) => {
    if (!o)
      u = a, o = p("Identifier"), r.push(o);
    else if (/[0-9a-zA-Z_$. ]/.test(a))
      u += a, (u == "null" || u == "undefined" || u == "true" || u == "false" || u == "void 0") && (o.type = "Literal"), P(o);
    else
      return y(a);
    return s(b(), o);
  }, n = (a, o) => (o = p("Punctuator"), r.push(o), /\(/.test(a) ? c.push(a) : /\)/.test(a) && c.pop(), y(b())), i = (a) => /\//.test(a) && /\*/.test(A()) ? y(a) : i(b()), m = () => r[r.length - 1]?.type === "Punctuator" && c.length === 0 || l === t.length, y = (a = t[l]) => m() ? r : E(a) ? S(a) : j(a) ? s(a) : x(a) ? n(a) : $(a) ? i(a) : y(b());
  return y();
}
function X(t, e, r) {
  let c, f = 0;
  const u = [], l = () => f < t.length - 1 ? t[f + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, p = () => t[++f], P = () => t[t.length - 1], b = (s) => s.replace(/^["'`]|["'`]$/g, ""), J = (s) => (c.arguments.push({ type: "Literal", value: b(s.value) }), $(p())), A = (s) => (c.arguments.push({ type: "Identifier", value: s.value }), $(p())), O = (s, n, i) => (i || (i = {
    type: "Property",
    key: { type: "Identifier", value: s.value },
    value: { type: "Literal", value: "" }
  }, n.push(i)), !/^:$/.test(s.value) && !/^:$/.test(l().value) ? s.type === "Literal" ? (i.value.value = b(s.value), j(p(), n)) : (i.value.type = "Expression", E(s, n, i)) : O(p(), n, i)), E = (s, n, i) => (i.value.value += s.value, /^[({]$/.test(s.value) ? u.push(s.value) : /^[)}]$/.test(s.value) && u.pop(), /^[,}]$/.test(l().value) && u.length === 0 ? j(p(), n) : E(p(), n, i)), j = (s, n) => (n || (n = [], c.arguments.push({ type: "ObjectExpression", properties: n })), /^}$/.test(s.value) ? $(p()) : /^:$/.test(l().value) ? O(s, n) : j(p(), n)), x = (s, n) => (n || (n = [], c.arguments.push({ type: "ArrayExpression", elements: n })), /^]$/.test(s.value) ? $(p()) : (s.type === "Literal" && n.push({ type: "Literal", value: b(s.value) }), s.type === "Identifier" && n.push({ type: "Identifier", value: s.value }), x(p(), n))), $ = (s) => Object.is(s, P()) ? c : s.type === "Literal" ? J(s) : s.type === "Identifier" && /^\($/.test(l().value) ? S(s) : s.type === "Identifier" ? A(s) : /^{$/.test(s.value) ? j(s) : /^\[$/.test(s.value) ? x(s) : $(p()), S = (s, n, i = s.position.start) => n ? /^\)$/.test(s.value) ? (n.value = e.substring(i, s.position.end + 1), $(p())) : S(p(), n, i) : new RegExp(r).test(s.value) ? (c = {
    type: "CallExpression",
    value: e.substring(i, P().position.end + 1),
    arguments: []
  }, $(p())) : (n = { type: "CallExpression", value: "" }, c.arguments.push(n), S(p(), n, i));
  return S(t[f]);
}
function Y(t, e) {
  const r = new RegExp(`${e}\\(`, "gs"), c = [];
  let f;
  for (; (f = r.exec(t)) !== null; )
    c.push(f.index);
  return c;
}
function F(t, e) {
  const r = [], c = Y(t, e);
  for (const f of c) {
    const u = G(t, f);
    if (u.length > 0)
      try {
        const l = X(u, t, e);
        l && r.push(l);
      } catch (l) {
        console.error(l), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          t.substring(f, u[u.length - 1].position.end) + `
`
        );
      }
  }
  return r;
}
function ee(t) {
  return /inlineTranslate/.test(t);
}
function te(t) {
  return /inlinePlural/.test(t);
}
function se(t) {
  let e = t.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function ne(t) {
  let e = t.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function re(t) {
  return JSON.parse(t, (e, r) => r === null ? void 0 : r);
}
function ae(t, e, r) {
  let c = 0;
  const f = e.length;
  for (; c < f; ) {
    const u = e[c++];
    t[u] = t[u] && !r ? t[u] : c === f ? r : typeof t[u] == "object" ? t[u] : {}, t = t[u];
  }
}
function R(t, e) {
  return typeof t == "object" && typeof e == "object" ? (Object.keys(e).map((r) => {
    t[r] = R(t[r], e[r]);
  }), t) : e;
}
function ie(t, e) {
  typeof t == "object" && typeof e == "object" && Object.keys(e).forEach((r) => {
    typeof e[r] == "object" ? r in t ? ie(t[r], e[r]) : Object.assign(t, { [r]: e[r] }) : !t[r] && e[r] && Object.assign(t, { [r]: e[r] });
  });
}
function le(t) {
  return typeof t == "object" ? JSON.parse(JSON.stringify(t)) : t;
}
function oe(t, e) {
  return t = { ...t, ...e }, t;
}
function ue(t) {
  return JSON.stringify(t, fe, 2);
}
function z(t) {
  return Object.keys(t).sort().reduce(
    (e, r) => (typeof t[r] == "object" && !Array.isArray(t[r]) ? e[r] = z(t[r]) : e[r] = t[r], e),
    {}
  );
}
function fe(t, e) {
  return typeof e == "string" ? e.replace(/\\/g, "") : e;
}
function ce(t, e) {
  const r = /* @__PURE__ */ new Set();
  for (let c = 0; c < 20; c++) {
    const f = new Intl.PluralRules(t, e).select(c);
    r.add(f);
  }
  return Array.from(r);
}
function pe(t) {
  let e;
  if (t) {
    e = {};
    for (const r of t)
      e = { ...e, [r.key.value]: r.value.value };
  }
  return e;
}
function D(t) {
  return Object.keys(t).sort().reduce((e, r) => (typeof t[r] == "object" && !Array.isArray(t[r]) && t[r] !== null ? e[r] = D(t[r]) : e[r] = t[r], e), {});
}
function M(t) {
  let e = "";
  switch (typeof t) {
    case "string":
      e = t;
      break;
    case "object":
      e = JSON.stringify(D(t));
      break;
    case "number":
      e = t.toString();
      break;
  }
  return `autoKey_${me(e)}`;
}
function ye(t) {
  return /^(?!\.)(?!.*\.\s)(?!.*\s\.)(?!.*\.$)(?=.*\..*)[^\s]+$/.test(t);
}
function de(t, e, r) {
  const c = e.split(r);
  if (t instanceof Map) {
    for (const f of t.values()) {
      let u = f;
      for (const l of c) {
        if (u[l] === void 0)
          return !1;
        u = u[l];
      }
    }
    return !0;
  }
  if (typeof t == "object") {
    let f = t;
    for (const u of c) {
      if (f[u] === void 0)
        return !1;
      f = f[u];
    }
    return !0;
  }
  return !0;
}
function me(t) {
  return H.createHash("md5").update(t).digest("hex");
}
async function be(t) {
  const e = {
    ...t,
    basePath: t.basePath ?? "./",
    sourceFilesPaths: t.sourceFilesPaths ?? ["src"],
    excludedPaths: t.excludedPaths ?? [],
    assetsPath: t.assetsPath ?? "i18n",
    format: t.format ?? "json",
    filename: t.filename ?? "app",
    fallback: t.fallback ?? ((s) => s),
    keySeparator: t.keySeparator ?? ".",
    keyValueSeparator: t.keyValueSeparator ?? "@@",
    autoKeys: t.autoKeys ?? !1
  }, r = /* @__PURE__ */ new Map(), c = e.sourceFilesPaths.map((s) => I(`${e.basePath}/${s}`)), f = e.excludedPaths.map((s) => I(`${e.basePath}/${s}`)), u = [];
  let l = Object.fromEntries(e.supportedLangs.map((s) => [s, {}]));
  const p = async (s, n) => {
    const i = await q(s, { withFileTypes: !0 });
    for (const m of i) {
      const y = Z(s, m.name), a = C(m.name);
      m.isDirectory() ? n.includes(y) || await p(y, n) : /\.js|\.ts|\.jsx|\.tsx/.test(a) && !/test|spec/.test(m.name) && u.push(y);
    }
  }, P = (s) => s.type === "Identifier" || s.type === "Literal" && s.value && /\${.*}/.test(s.value) ? (r.set("dynamic", (r.get("dynamic") ?? 0) + 1), !0) : !1, b = async (s) => {
    const n = [];
    let i = await N(I(`${e.basePath}/${s}`), "utf8");
    const m = (a) => {
      i = i.replace(new RegExp(`${a}<.*>\\(`, "g"), `${a.replace("\\b", "")}(`);
    }, y = (a) => {
      for (const o of a) {
        const v = o.arguments;
        if (v?.length > 0) {
          if (v[0].type === "ArrayExpression") {
            if (v[0].elements) {
              for (const g of v[0].elements)
                if (g.type === "Literal") {
                  if (P(g))
                    continue;
                  n.push(g.value);
                }
            }
          } else if (v?.[0]?.value) {
            if (P(v[0]))
              continue;
            n.push(v[0].value);
          }
        }
      }
    };
    if (ee(i)) {
      const a = se(i);
      if (a) {
        m(a);
        const o = F(i, a);
        y(o);
      }
    }
    if (te(i)) {
      const a = ne(i);
      if (a) {
        const o = F(i, a);
        for (const v of o) {
          const g = v.arguments;
          if (g?.length > 0) {
            if (g[1]?.type === "Identifier" || g[1]?.type === "CallExpression" || g[3]?.type === "Identifier" || g[3]?.type === "CallExpression") {
              r.set("dynamic plural", (r.get("dynamic plural") ?? 0) + 1);
              continue;
            }
            const L = /* @__PURE__ */ new Set(), U = pe(g[3]?.properties);
            for (const d of e.supportedLangs) {
              const V = ce(d, U);
              for (const k of V)
                L.add(k);
            }
            const B = (d) => !d || d === "undefined" || d === "null", _ = (d, V) => d.split(V);
            let h = g[1]?.value, K;
            h && ([h, K] = _(h, e.keyValueSeparator), !K && /^{.*}$/.test(h) && (K = h, h = void 0));
            const w = K ? JSON.parse(K) : void 0;
            if (!B(h) && !w) {
              const d = {};
              for (const V of L)
                d[V] = "";
              n.push(`${h}${e.keyValueSeparator}${JSON.stringify(d)}`);
            } else if (B(h) && !w)
              for (const d of L)
                n.push(d);
            else if (!B(h) && w) {
              for (const d of L)
                w[d] || (w[d] = "");
              n.push(`${h}${e.keyValueSeparator}${JSON.stringify(w)}`);
            } else if (B(h) && w) {
              h = M(w);
              for (const d of L)
                w[d] || (w[d] = "");
              n.push(`${h}${e.keyValueSeparator}${JSON.stringify(w)}`);
            }
          }
        }
      }
    }
    return n;
  }, J = async () => {
    const s = /* @__PURE__ */ new Map();
    for (const n of e.supportedLangs) {
      const i = I(`${e.basePath}/${e.assetsPath}/${n}`);
      if (T(i)) {
        const m = await q(i);
        if (m.length > 0) {
          const y = C(m[0]);
          let a = {};
          const o = m.map((g) => N(`${i}/${g}`, "utf8")), v = await Promise.all(o);
          for (const g of v)
            if (g) {
              let L = {};
              switch (y) {
                case ".json":
                  L = re(g);
                  break;
              }
              a = oe(a, L);
            }
          s.set(n, a);
        }
      }
    }
    return s;
  }, A = async (s) => {
    for (const n of e.supportedLangs) {
      const i = I(`${e.basePath}/${e.assetsPath}/${n}`);
      T(i) || W(i, { recursive: !0 });
      const m = Object.keys(l[n]).filter((o) => !s.includes(o)), y = Object.keys(l[n]).filter((o) => s.includes(o)), a = {};
      l[n][e.filename] && (a[e.filename] = l[n][e.filename]);
      for (const o of y)
        a[o] = l[n][o];
      Object.keys(a).length > 0 && await O(a, e.filename, i);
      for (const o of m.filter((v) => v !== e.filename))
        await O({ [o]: l[n][o] }, o, i);
    }
  }, O = async (s, n, i) => {
    let m;
    switch (e.format) {
      case "json":
        m = ue(s);
        break;
    }
    const y = I(`${i}/${n}.${e.format}`);
    await Q(y, m), console.log(y);
  };
  for (const s of c)
    await p(s, f);
  const E = u.map((s) => b(s)), j = await Promise.all(E);
  let x = [];
  for (const s of j)
    x = x.concat(s);
  x = [...new Set(x)], r.set("unique keys", (r.get("unique keys") ?? 0) + x.length);
  const $ = [], S = await J();
  for (let s of x) {
    let n;
    [s, n] = s.split(e.keyValueSeparator), /^[[{].*[\]}]$/.test(n) && !/^{{/.test(n) && (n = JSON.parse(n)), e.autoKeys && s && !n && !ye(s) && !de(S, s, e.keySeparator) && (n = `${s}`, s = M(s));
    for (const i of e.supportedLangs)
      ae(l[i], s.split(e.keySeparator), le(n || ""));
    $.push(s);
  }
  if (S.size > 0)
    for (const [s, n] of S)
      R(l[s], n);
  for (const s of e.supportedLangs)
    l[s] = z(l[s]);
  l = e.fallback(l), await A($);
  for (const [s, n] of r)
    switch (s) {
      case "unique keys":
        console.log("\x1B[32m%s\x1B[0m", `extracted keys: ${n}`);
        break;
      case "dynamic":
        console.log("\x1B[32m%s\x1B[0m", `translations skipped due to dynamic keys: ${n}`);
        break;
      case "dynamic plural":
        console.log("\x1B[32m%s\x1B[0m", `plurals skipped due to dynamic keys/options: ${n}`);
        break;
    }
}
export {
  ie as deepMergeMissing,
  be as qwikSpeakExtract
};
