import { readdir as ee, readFile as te, writeFile as K } from "fs/promises";
import { existsSync as J, createWriteStream as ne, mkdirSync as se } from "fs";
import { normalize as k, extname as re } from "path";
import ie from "crypto";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function ae(e, t = 0) {
  const n = [], r = [], l = [];
  let u = "", a = t;
  const o = (p) => (t = a, { type: p, value: m(), position: { start: t, end: a } }), s = (p) => {
    p.value = m(), p.position.start = t, p.position.end = a;
  }, i = () => e[++a], f = () => a < e.length - 1 ? e[a + 1] : "", y = () => a > 0 ? e[a - 1] : "", m = () => e.substring(t, a + 1), d = (p) => /["'`0-9+-]/.test(p), b = (p) => /[a-zA-Z_$]/.test(p), $ = (p) => /[(){},:;.[\]?!=<>]/.test(p), P = (p) => /\//.test(p) && /\*/.test(f()), w = (p, h) => {
    if (!h)
      h = o("Literal"), n.push(h);
    else {
      if (l.length === 0 && !/[0-9.]/.test(p))
        return I(p);
      s(h);
    }
    return l.length === 0 && /["'`]/.test(p) ? l.push(p) : l.length > 0 && l[l.length - 1] === p && (/\\/.test(y()) || l.pop()), w(i(), h);
  }, c = (p, h) => {
    if (!h)
      u = p, h = o("Identifier"), n.push(h);
    else if (/[0-9a-zA-Z_$. ]/.test(p))
      u += p, (u == "null" || u == "undefined" || u == "true" || u == "false" || u == "void 0") && (h.type = "Literal"), s(h);
    else
      return I(p);
    return c(i(), h);
  }, g = (p, h) => (h = o("Punctuator"), n.push(h), /\(/.test(p) ? r.push(p) : /\)/.test(p) && r.pop(), I(i())), v = (p) => /\//.test(p) && /\*/.test(y()) ? I(p) : v(i()), Y = () => n[n.length - 1]?.type === "Punctuator" && r.length === 0 || a === e.length, I = (p = e[a]) => Y() ? n : d(p) ? w(p) : b(p) ? c(p) : $(p) ? g(p) : P(p) ? v(p) : I(i());
  return I();
}
function le(e, t, n) {
  let r, l = 0;
  const u = [], a = () => l < e.length - 1 ? e[l + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, o = () => e[++l], s = () => e[e.length - 1], i = (c) => c.replace(/^["'`]|["'`]$/g, ""), f = (c) => (r.arguments.push({ type: "Literal", value: i(c.value) }), P(o())), y = (c) => (r.arguments.push({ type: "Identifier", value: c.value }), P(o())), m = (c, g, v) => (v || (v = {
    type: "Property",
    key: { type: "Identifier", value: c.value },
    value: { type: "Literal", value: "" }
  }, g.push(v)), !/^:$/.test(c.value) && !/^:$/.test(a().value) ? c.type === "Literal" ? (v.value.value = i(c.value), b(o(), g)) : (v.value.type = "Expression", d(c, g, v)) : m(o(), g, v)), d = (c, g, v) => (v.value.value += c.value, /^[({]$/.test(c.value) ? u.push(c.value) : /^[)}]$/.test(c.value) && u.pop(), /^[,}]$/.test(a().value) && u.length === 0 ? b(o(), g) : d(o(), g, v)), b = (c, g) => (g || (g = [], r.arguments.push({ type: "ObjectExpression", properties: g })), /^}$/.test(c.value) ? P(o()) : /^:$/.test(a().value) ? m(c, g) : b(o(), g)), $ = (c, g) => (g || (g = [], r.arguments.push({ type: "ArrayExpression", elements: g })), /^]$/.test(c.value) ? P(o()) : (c.type === "Literal" && g.push({ type: "Literal", value: i(c.value) }), c.type === "Identifier" && g.push({ type: "Identifier", value: c.value }), $(o(), g))), P = (c) => Object.is(c, s()) ? r : c.type === "Literal" ? f(c) : c.type === "Identifier" && /^\($/.test(a().value) ? w(c) : c.type === "Identifier" ? y(c) : /^{$/.test(c.value) ? b(c) : /^\[$/.test(c.value) ? $(c) : P(o()), w = (c, g, v = c.position.start) => g ? /^\)$/.test(c.value) ? (g.value = t.substring(v, c.position.end + 1), P(o())) : w(o(), g, v) : new RegExp(n).test(c.value) ? (r = {
    type: "CallExpression",
    value: t.substring(v, s().position.end + 1),
    arguments: []
  }, P(o())) : (g = { type: "CallExpression", value: "" }, r.arguments.push(g), w(o(), g, v));
  return w(e[l]);
}
function ue(e, t) {
  const n = new RegExp(`${t}\\(`, "gs"), r = [];
  let l;
  for (; (l = n.exec(e)) !== null; )
    r.push(l.index);
  return r;
}
function E(e, t) {
  const n = [], r = ue(e, t);
  for (const l of r) {
    const u = ae(e, l);
    if (u.length > 0)
      try {
        const a = le(u, e, t);
        a && n.push(a);
      } catch (a) {
        console.error(a), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          e.substring(l, u[u.length - 1].position.end) + `
`
        );
      }
  }
  return n;
}
function N(e) {
  return /inlineTranslate/.test(e);
}
function F(e) {
  return /inlinePlural/.test(e);
}
function Q(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function W(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function oe(e) {
  return JSON.parse(e, (t, n) => n === null ? void 0 : n);
}
function fe(e, t) {
  const n = /* @__PURE__ */ new Set();
  for (let r = 0; r < 20; r++) {
    const l = new Intl.PluralRules(e, t).select(r);
    n.add(l);
  }
  return Array.from(n);
}
function ce(e) {
  let t;
  if (e) {
    t = {};
    for (const n of e)
      t = { ...t, [n.key.value]: n.value.value };
  }
  return t;
}
function pe(e, t) {
  return e = { ...e, ...t }, e;
}
function z(e) {
  return Object.keys(e).sort().reduce((t, n) => (typeof e[n] == "object" && !Array.isArray(e[n]) && e[n] !== null ? t[n] = z(e[n]) : t[n] = e[n], t), {});
}
function G(e) {
  let t = "";
  switch (typeof e) {
    case "string":
      t = e;
      break;
    case "object":
      t = JSON.stringify(z(e));
      break;
    case "number":
      t = e.toString();
      break;
  }
  return `autoKey_${ye(t)}`;
}
function R(e, t, n) {
  const r = t.split(n);
  if (e instanceof Map) {
    for (const l of e.values()) {
      let u = l;
      for (const a of r) {
        if (u[a] === void 0)
          return !1;
        u = u[a];
      }
    }
    return !0;
  }
  if (typeof e == "object") {
    let l = e;
    for (const u of r) {
      if (l[u] === void 0)
        return !1;
      l = l[u];
    }
    return !0;
  }
  return !0;
}
function ye(e) {
  return ie.createHash("md5").update(e).digest("hex");
}
const O = "__qsInlineTranslate", T = "__qsInlinePlural", V = [], j = [], ge = (e, t) => `${e} - ${t}`, me = (e, t) => `dynamic ${t}: ${e}`;
let S, A, L;
function Ke(e) {
  let t = "";
  const n = async (s) => {
    const i = k(`${t}/${s}`);
    let f = {};
    if (J(i)) {
      const y = await ee(i);
      if (y.length > 0) {
        const m = re(y[0]), d = y.map(($) => te(`${i}/${$}`, "utf8")), b = await Promise.all(d);
        for (const $ of b)
          if ($) {
            let P = {};
            switch (m) {
              case ".json":
                P = oe($);
                break;
            }
            f = pe(f, P);
          }
      }
    }
    return f;
  }, r = {
    ...e,
    basePath: e.basePath ?? "./",
    assetsPath: e.assetsPath ?? "i18n",
    loadAssets: e.loadAssets ?? n,
    outDir: e.outDir ?? "dist",
    keySeparator: e.keySeparator ?? ".",
    keyValueSeparator: e.keyValueSeparator ?? "@@",
    autoKeys: e.autoKeys ?? !1
  };
  t = `${r.basePath}/${r.assetsPath}`;
  const l = Object.fromEntries(r.supportedLangs.map((s) => [s, {}]));
  let u;
  const a = /* @__PURE__ */ new Set();
  return {
    name: "vite-plugin-qwik-speak-inline",
    enforce: "post",
    apply: void 0,
    // both
    configResolved(s) {
      s.build?.ssr || s.mode === "ssr" ? S = "ssr" : s.mode === "lib" ? S = "lib" : s.mode === "test" ? S = "test" : S = "client", A = s.isProduction || s.mode === "production" ? "prod" : "dev";
      const i = s.build?.rollupOptions?.input;
      i && (Array.isArray(i) ? L = i[0] : typeof i == "string" && (L = i)), L = L?.split("/")?.pop();
    },
    configureServer(s) {
      A === "dev" && s.ws.on("qwik-speak:lang", (i) => {
        if (u && u !== i.msg) {
          for (const f of a) {
            const y = s.moduleGraph.getModuleById(f);
            y && s.moduleGraph.invalidateModule(y);
          }
          a.clear();
        }
        u = i.msg;
      });
    },
    async handleHotUpdate({ file: s, server: i }) {
      if (new RegExp(r.assetsPath).test(s) && /\.(json)$/.test(s)) {
        for (const f of r.supportedLangs)
          new RegExp(f).test(s) && await n(f);
        for (const f of a) {
          const y = i.moduleGraph.getModuleById(f);
          y && i.moduleGraph.invalidateModule(y);
        }
        a.clear();
      }
    },
    /**
     * Load translation files when build starts
     */
    async buildStart() {
      await Promise.all(r.supportedLangs.map(async (s) => {
        const i = await r.loadAssets(s);
        Object.assign(l[s], i);
      }));
    },
    /**
     * Transform functions
     * Prefer transform hook because unused imports will be removed, unlike renderChunk
     */
    async transform(s, i, f) {
      return r.autoKeys && /\/src\//.test(i) && /\.(js|cjs|mjs|jsx|ts|tsx)$/.test(i) && (F(s) && (s = ve(s, r, l)), N(s) && (s = $e(s, r, l))), (S === "client" || S === "ssr" && f?.ssr === !1) && /\/src\//.test(i) && /\.(js|cjs|mjs|jsx|ts|tsx)$/.test(i) && (F(s) && (s = xe(s)), N(s) && (s = he(s)), A === "dev" && (s.includes(O) || s.includes(T)) && (s = U(s, u, r, l), a.add(i))), S === "ssr" && (i.endsWith("entry.ssr.tsx") || i.endsWith("entry.ssr.jsx")) && (/(?<!\/\/\s*)base:\s*extractBase/.test(s) || (console.log(
        `
\x1B[31mQwik Speak Inline error\x1B[0m
%s`,
        "Missing 'base' option in 'entry.ssr.tsx' file: see https://robisim74.gitbook.io/qwik-speak/tools/setup"
      ), process.exit(1))), s;
    },
    /**
     * Split chunks by lang
     */
    async writeBundle(s, i) {
      if (S === "client") {
        const f = s.dir ? s.dir : k(`${r.basePath}/${r.outDir}`), y = Object.values(i), m = r.supportedLangs.map((d) => de(d, y, f, l, r));
        await Promise.all(m);
      }
    },
    async closeBundle() {
      if (S === "client") {
        const s = ne("./qwik-speak-inline.log", { flags: "w" });
        s.write(`${S}: ` + (L ?? "-") + `
`), V.length > 0 && (s.write(`
Missing value for keys:
`), V.forEach((i) => s.write(i + `
`))), j.length > 0 && (s.write(`
Make sure the keys are in 'runtimeAssets':
`), j.forEach((i) => s.write(i + `
`))), s.write(`
Qwik Speak Inline: build ends at ${(/* @__PURE__ */ new Date()).toLocaleString()}
`), (V.length > 0 || j.length > 0) && console.log(
          `
\x1B[33mQwik Speak Inline warn\x1B[0m
%s`,
          "There are missing values or dynamic keys: see ./qwik-speak-inline.log"
        );
      }
    }
  };
}
async function de(e, t, n, r, l) {
  const u = k(`${n}/build/${e}`);
  J(u) || se(u, { recursive: !0 });
  for (const a of t) {
    const o = [];
    if (a.type === "chunk" && "code" in a && /build\//.test(a.fileName)) {
      const s = k(`${u}/${a.fileName.split("/")[1]}`);
      let i = a.code;
      if (i = U(i, e, l, r), o.push(K(s, i)), e === l.defaultLang) {
        const f = k(`${n}/build`), y = k(`${f}/${a.fileName.split("/")[1]}`);
        o.push(K(y, i));
      }
    }
    await Promise.all(o);
  }
}
function $e(e, t, n) {
  const r = Q(e);
  if (!r)
    return e;
  const l = E(e, r);
  if (l.length === 0)
    return e;
  for (const u of l) {
    const a = u.value, o = u.arguments;
    if (o?.length > 0) {
      if (H(o, a))
        continue;
      if (o[0].value) {
        const s = o[0].value, [i] = B(s, t.keyValueSeparator), f = G(s);
        if (!R(n[t.defaultLang], i, t.keySeparator) && R(n[t.defaultLang], f, t.keySeparator)) {
          const y = a.replace(s, `${f}${t.keyValueSeparator}${s}`);
          e = e.replace(a, y);
        }
      }
    }
  }
  return e;
}
function ve(e, t, n) {
  const r = W(e);
  if (!r)
    return e;
  const l = E(e, r);
  if (l.length === 0)
    return e;
  for (const u of l) {
    const a = u.value, o = u.arguments;
    if (o?.length > 0) {
      if (Z(o, a))
        continue;
      if (o[1]?.value) {
        const s = (d) => !d || d === "undefined" || d === "null", i = o[1].value;
        let f, y;
        i && ([f, y] = B(i, t.keyValueSeparator), !y && /^{.*}$/.test(f) && (y = f, f = void 0));
        const m = y ? JSON.parse(y) : void 0;
        if (s(f) && m) {
          const d = G(m);
          if (R(n[t.defaultLang], d, t.keySeparator)) {
            const b = a.replace(i, `${d}${t.keyValueSeparator}${y}`);
            e = e.replace(a, b);
          }
        }
      }
    }
  }
  return e;
}
function he(e) {
  const t = Q(e);
  if (!t)
    return e;
  let n = !1;
  const r = E(e, t);
  if (r.length === 0)
    return e;
  for (const l of r) {
    const u = l.value, a = l.arguments;
    if (a?.length > 0) {
      if (H(a, u)) {
        n = !0;
        continue;
      }
      const o = u.replace(new RegExp(`${t}\\(`), `${O}(`);
      e = e.replace(u, o);
    }
  }
  return n || (e = Ae(e, t)), e;
}
function xe(e) {
  const t = W(e);
  if (!t)
    return e;
  let n = !1;
  const r = E(e, t);
  if (r.length === 0)
    return e;
  for (const l of r) {
    const u = l.value, a = l.arguments;
    if (a?.length > 0) {
      if (Z(a, u)) {
        n = !0;
        continue;
      }
      const o = u.replace(new RegExp(`${t}\\(`), `${T}(`);
      e = e.replace(u, o);
    }
  }
  return n || (e = qe(e, t)), e;
}
function U(e, t, n, r) {
  return e.includes(T) && (e = Pe(e, T, O, t, n)), e.includes(O) && (e = be(e, r, O, t, n)), e;
}
function be(e, t, n, r, l) {
  const u = E(e, n);
  if (u.length === 0)
    return e;
  for (const a of u) {
    const o = a.value, s = a.arguments;
    if (s?.length > 0) {
      const i = X(r, s[2], l);
      let f = x("");
      if (s[0].type === "ArrayExpression") {
        const m = ke(s[0]), d = [];
        for (const b of m) {
          const $ = M(
            b,
            t[i],
            s[1],
            l.keySeparator,
            l.keyValueSeparator,
            i
          );
          d.push($);
        }
        f = d;
      } else if (s?.[0]?.value) {
        const m = Ie(s[0]);
        f = M(
          m,
          t[i],
          s[1],
          l.keySeparator,
          l.keyValueSeparator,
          i
        );
      }
      const y = we(f);
      e = e.replace(o, y);
    }
  }
  return e;
}
function Pe(e, t, n, r, l) {
  const u = E(e, t);
  if (u.length === 0)
    return e;
  for (const a of u) {
    const o = a.value, s = a.arguments;
    if (s?.length > 0) {
      const i = X(r, s[4], l), f = ce(s[3]?.properties), y = fe(i, f), m = Se(y, i, n, s, l);
      e = e.replace(o, m);
    }
  }
  return e;
}
function we(e) {
  return typeof e == "object" ? `${Oe(e)}` : e;
}
function Se(e, t, n, r, l) {
  let u = "";
  return u += ((o) => {
    let s = "(";
    for (const i of e) {
      let f = r[1]?.value, y;
      f && ([f, y] = B(f, l.keyValueSeparator), !y && /^{.*}$/.test(f) && (y = f, f = void 0)), f = f ? `${f}${l.keySeparator}${i}` : i;
      const m = y ? JSON.parse(y)[i] : void 0;
      m && (f = `${f}${l.keyValueSeparator}${m}`);
      const d = [{
        type: "Property",
        key: { type: "Identifier", value: "value" },
        value: { type: "Expression", value: r[0].value }
      }];
      if (r[2]?.properties)
        for (const $ of r[2].properties)
          d.push($);
      const b = d.map(($) => `${$.key.value}: ${C($)}`).join(", ");
      if (i !== e[e.length - 1]) {
        const $ = r[3]?.properties?.map((w) => `${w.key.value}: ${C(w)}`)?.join(", "), P = Le(o, r[0].value, i, $);
        s += P + ` && ${n}(${x(f)}, {${b}}, ${x(o)}) || `;
      } else
        s += `${n}(${x(f)}, {${b}}, ${x(o)})`;
    }
    return s += ")", s;
  })(t), u;
}
function H(e, t) {
  if (e?.[0]?.value) {
    if (e[0].type === "Identifier" || e[0].type === "Literal" && /\${.*}/.test(e[0].value))
      return q(t, "key"), !0;
    if (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression")
      return q(t, "params"), !0;
  }
  return !1;
}
function Z(e, t) {
  return e?.[0]?.value && (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression" || e[3]?.type === "Identifier" || e[3]?.type === "CallExpression" || e[4]?.type === "Identifier" || e[4]?.type === "CallExpression") ? (q(t, "params"), !0) : !1;
}
function X(e, t, n) {
  let r;
  return t?.type === "Literal" && (r = n.supportedLangs.find((l) => l === t.value)), r ?? e;
}
function Ie(e) {
  return e.value;
}
function ke(e) {
  const t = [];
  if (e.elements)
    for (const n of e.elements)
      n.type === "Literal" && t.push(n.value);
  return t;
}
const B = (e, t) => e.split(t);
function M(e, t, n, r, l, u) {
  let a;
  [e, a] = B(e, l);
  const o = e.split(r).reduce((s, i) => s && s[i] !== void 0 ? s[i] : void 0, t);
  if (o) {
    if (typeof o == "string")
      return n ? _(o, n) : x(o);
    if (typeof o == "object")
      return n ? D(o, n) : o;
  } else
    u && Ve(u, e);
  return a ? !/^[[{].*[\]}]$/.test(a) || /^{{/.test(a) ? n ? _(a, n) : x(a) : n ? D(JSON.parse(a), n) : JSON.parse(a) : x(A === "dev" ? e : "");
}
function D(e, t) {
  return Object.keys(e).map((n) => {
    typeof e[n] == "string" && (e[n] = t ? _(e[n], t) : x(e[n])), e[n] && typeof e[n] == "object" && (e[n] = D(e[n], t));
  }), e;
}
function _(e, t) {
  if (t.properties)
    for (const n of t.properties)
      e = e.replace(/{{\s?([^{}\s]*)\s?}}/g, (r, l) => l === n.key.value ? Ee(n) : r);
  return x(e);
}
function x(e) {
  return /^`.*`$/.test(e) ? e : "`" + e + "`";
}
function Ee(e) {
  return e.value.type === "Literal" ? e.value.value : "${" + e.value.value + "}";
}
function C(e) {
  return e.value.type === "Literal" ? x(e.value.value) : e.value.value;
}
function Le(e, t, n, r) {
  return r ? `new Intl.PluralRules(${x(e)}, {${r}}).select(+${t}) === ${x(n)}` : `new Intl.PluralRules(${x(e)}).select(+${t}) === ${x(n)}`;
}
function Oe(e) {
  let t = JSON.stringify(e, Te);
  return t = t.replace(/("__qsOpenBt)|(__qsCloseBt")/g, "`"), t;
}
function Ve(e, t) {
  const n = ge(e, t);
  V.includes(n) || V.push(n);
}
function q(e, t) {
  const n = me(je(e), t);
  j.includes(n) || j.push(n);
}
function je(e) {
  return e.replace(/\s+/g, " ").trim();
}
function Ae(e, t) {
  return e.replace(new RegExp(`\\bconst\\s${t}\\s=\\sinlineTranslate\\(\\);?`, "g"), "");
}
function qe(e, t) {
  return e.replace(new RegExp(`\\bconst\\s${t}\\s=\\sinlinePlural\\(\\);?`, "g"), "");
}
function Te(e, t) {
  return typeof t == "string" && /^`.*`$/.test(t) ? t.replace(/^`/, "__qsOpenBt").replace(/`$/, "__qsCloseBt") : t;
}
function Ne(e, t) {
  return t !== "production" ? e : e.map((r) => ({
    prefix: r.domain ? void 0 : r.prefix,
    paths: r.paths,
    lang: r.prefix,
    domain: r.domain,
    withDomain: r.withDomain
  }));
}
export {
  Ke as qwikSpeakInline,
  Ne as toPrefixAsNeeded
};
